/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2016 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/* set debug_level=1. */


/* run */ define test() = {
  exists X #2 : {
    X=0 and len(3) and X gets X+1 and 
   always (
     output(X) and
     output(prev(X)) and 
     output(prev(prev(X))) and
     if more then (
         output(next(X)) and
         output(next(prev(X))) and
         output(next(prev(prev(X)))) and
         output(prev(next(prev(X)))) and
         output(prev(prev(next(X)))) 
     )
   )
  }
}.

/* run */ define testa() = {
  exists X #2 : {
    X=0 and len(3) and X gets X+1 and 
   always (
     output(X) and
     output(prev(X)) and 
     output(nprev(X,2)) and
     if more then (
         output(next(X)) and
         output(next(prev(X))) and
         output(prev(next(X))) and
         output(next(nprev(X,3))) and
         output(prev(next(nprev(X,2)))) and
         output(nprev(next(X),3)) 
     )
   )
  }
}.

/* run */ define test1() = {
  exists X #1 : {
    exists Y #2 : {
      X is 2**Y and len(4) and Y=0 and Y gets Y + 1 and always(output(X)
      and output(Y) and output(prev(Y)) and output(prev(prev(Y))))
    }
  }
}.

/* this test should fail */
/* run */ define test2() = {
  exists X #1 : {
    exists Y #2 : {
      X is 2**Y and len(4) and Y=0 and Y gets Y + 1 and always(output(X)
      and output(Y) and output(nprev(Y,3)) and output(prev(prev(Y))))
    }
  }
}.
