/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2016 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

load "../library/conversion".
load "../library/exprog".

/* java Hello1 0 */

set print_states = false.

define get_var(X,Y) = 
{
    exists T : {
        get2(T) and 
        if avar(T)=X then {Y=strint(aval(T))}        
        else empty
    }
}.

/* run */ define test() = exists Name: {
get_var("Name", Name) and len(0) and output(Name)
}.
